#region File Description
//-----------------------------------------------------------------------------
//	Programozsi nyelvek 4. szeminrium 
//	Kurucz Attila
//	2009
//
// Game1.cs
//
// Microsoft XNA Community Game Platform
// Copyright (C) Microsoft Corporation. All rights reserved.
//-----------------------------------------------------------------------------
#endregion

#region Using Statements
using System;
using System.Collections.Generic;
using System.Collections;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Storage;
#endregion

namespace BeginnersGuide_2DGame_Windows
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        /* --------------------------------------------------------------
           ------------      1_plda - httr rajzols     -------------
           -------------------------------------------------------------- */
        GraphicsDeviceManager graphics;
        Rectangle viewportRect;
        GameObject ball;
        SpriteBatch spriteBatch;
        GamePadState previousGamePadState = GamePad.GetState(PlayerIndex.One);
        KeyboardState previousKeyboardState = Keyboard.GetState();
        public SoundEffect bounceSound;
        float moveVelocity = 2.0f;
        float ballSlow = 0.99f;
        float ballGrav = 0.5f;
        float ballSlowOnFloor = 0.8f;
        bool isSound = true; // 5_plda - HANGOK

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";
            this.graphics.PreferredBackBufferWidth = 800;
            this.graphics.PreferredBackBufferHeight = 600;
            //this.graphics.IsFullScreen = true;
            //this.IsFixedTimeStep = false; //6_plda - korlt
            //graphics.SynchronizeWithVerticalRetrace = false;
        }
        /// <summary>
        /// Allows the game to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        protected override void Initialize()
        {
            base.Initialize();
        }

        /// <summary>
        /// Load your graphics content
        /// </summary>
        /* --------------------------------------------------------------
           -----------      TEXTURK, HANGOK BETLTSE     --------------
           -------------------------------------------------------------- */
        protected override void LoadContent()
        {
            spriteBatch = new SpriteBatch(graphics.GraphicsDevice);
            ball = new GameObject(Content.Load<Texture2D>("Sprites\\ball"));
            bounceSound = Content.Load<SoundEffect>("Audio\\bounce");
            viewportRect = new Rectangle(0, 0,
                graphics.GraphicsDevice.Viewport.Width,
                graphics.GraphicsDevice.Viewport.Height);
            base.LoadContent();
            ball.position = new Vector2(graphics.GraphicsDevice.Viewport.Width / 2, graphics.GraphicsDevice.Viewport.Height / 2);
        }

        /// <summary>
        /// Unload any content not managed by the Content Manager
        /// </summary>
        protected override void UnloadContent()
        {
            base.UnloadContent();
        }

        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        /* --------------------------------------------------------------
           ---------------------      UPDATE - ALL     ------------------
           -------------------------------------------------------------- */
        protected override void Update(GameTime gameTime)
        {
#if !XBOX
            KeyboardState keyboardState = Keyboard.GetState();
            /* --------------------------------------------------------------
               ------------      3_plda - labda mozgatsa     -------------
               -------------------------------------------------------------- */

            if (keyboardState.IsKeyDown(Keys.Left)) ball.velocity.X += -moveVelocity;
            if (keyboardState.IsKeyDown(Keys.Up)) ball.velocity.Y += -moveVelocity;
            if (keyboardState.IsKeyDown(Keys.Down)) ball.velocity.Y += moveVelocity;
            if (keyboardState.IsKeyDown(Keys.Right)) ball.velocity.X += moveVelocity;
             

            if (keyboardState.IsKeyDown(Keys.Escape))
            {
                this.Exit();
            }
#endif

            /* --------------------------------------------------------------
               -----------      5_plda - labda gravitci     -------------
               -------------------------------------------------------------- */
            ball.velocity.Y += ballGrav;
            

            ball.velocity *= ballSlow;
            ball.position += ball.velocity;

            /* --------------------------------------------------------------
               ------------      4_plda - labda pattans    -------------
               -------------------------------------------------------------- */
            // ----------    PATTANS LENT ----------------
            if (ball.position.Y + ball.sprite.Height > graphics.GraphicsDevice.Viewport.Height) 
            {
                ball.position.Y -= 2 * (ball.position.Y + ball.sprite.Height - graphics.GraphicsDevice.Viewport.Height);
                ball.velocity.Y *= -1;
                ball.velocity.Y *= ballSlowOnFloor;
                float soundVolume = Math.Abs(ball.velocity.Y) / 20.0f;
                if (Math.Abs(ball.velocity.Y) < 1.3f) ball.velocity.Y = 0.0f;
                else if (isSound) bounceSound.Play(soundVolume);
            }
            // ----------    PATTANS FENT ----------------
            if (ball.position.Y < 0)
            {
                ball.position.Y -= 2 * ball.position.Y;
                ball.velocity.Y *= -1;
                float soundVolume = Math.Abs(ball.velocity.Y) / 20.0f;
                if (Math.Abs(ball.velocity.Y) > 0.8f && isSound) bounceSound.Play(soundVolume);
            }
            // ----------    PATTANS BAL OLDALT ----------------
            if (ball.position.X < 0)
            {
                ball.position.X -= 2 * ball.position.X;
                ball.velocity.X *= -1;
                float soundVolume = Math.Abs(ball.velocity.X) / 20.0f;
                if (Math.Abs(ball.velocity.Y) > 0.8f && isSound) bounceSound.Play(soundVolume);
            }
            // ----------    PATTANS JOBB OLDALT ----------------
            if (ball.position.X + ball.sprite.Width > graphics.GraphicsDevice.Viewport.Width)
            {
                ball.position.X -= 2 * (ball.position.X + ball.sprite.Width - graphics.GraphicsDevice.Viewport.Width);
                ball.velocity.X *= -1;
                float soundVolume = Math.Abs(ball.velocity.X) / 20.0f;
                if (Math.Abs(ball.velocity.Y) > 0.8f && isSound) bounceSound.Play(soundVolume);
            }
            
            // TODO: Add your update logic here 

            //previousGamePadState = gamePadState;
#if !XBOX
            previousKeyboardState = keyboardState;
#endif

            base.Update(gameTime);
        }



        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        /* --------------------------------------------------------------
           ----------------------      DRAW     -------------------------
           -------------------------------------------------------------- */
        protected override void Draw(GameTime gameTime)
        {
            /* --------------------------------------------------------------
               ------------      2_plda - labda rajzols     -------------
               -------------------------------------------------------------- */
            graphics.GraphicsDevice.Clear(Color.CornflowerBlue);
            spriteBatch.Begin(SpriteBlendMode.AlphaBlend);
              spriteBatch.Draw(ball.sprite, ball.position, Color.White);
            spriteBatch.End();
            base.Draw(gameTime);
        }
    }
}
