﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Storage;

namespace BeginnersGuide_2DGame_Windows
{
    class Asteroid : GameObject
    {
        /* --------------------------------------------------------------
          ----------------------      DEKLARÁCIÓK     ------------------
          -------------------------------------------------------------- */
        float rotationVelocity;
        int scx, scy;
        public int state;           // 0-disabled, 1-live, 2-dead(animation)
        public int size;
        public float VelocitySensX = 0;
        public float VelocitySensY = 0;
        static private Random random;
        const int frameCount = 16;
        public int currentFrame = 0;
        //float interval = 1000f / 25f; 
        
        /* --------------------------------------------------------------
           ----------------------      BEÁLLÍTÁSOK     ------------------
           -------------------------------------------------------------- */
        const int minSize = 20;
        const int maxSize = 60;
        const int minRotation = 1;
        const int maxRotation = 10;
        const float MinVelocity = 1.0f; 
        const float MaxVelocity = 2.5f;

        /* --------------------------------------------------------------
           ------------------------      ASTEROID     -------------------
           -------------------------------------------------------------- */
        public Asteroid(int ScreenX, int ScreenY)
            : base(null)
        {
            scx = ScreenX;
            scy = ScreenY;
            if (random==null)random = new Random();
            Restart();
        }

        /* --------------------------------------------------------------
           -------------------------      RESTART     -------------------
           -------------------------------------------------------------- */
        public void Restart()
        {
            state = 1;
            SetSize();
            SetStartPos();
        }

        /* --------------------------------------------------------------
           -------------------------      UPDATE     --------------------
           -------------------------------------------------------------- */
        public void Update()
        {
            rotation += rotationVelocity;
            position += velocity;
            if (position.X - size > scx) Restart();     // jobb
            if (position.X + size < 0) Restart();       // bal
            if (position.Y - size > scy) Restart();     // lent
            if (position.Y + size < 0) Restart();       // fent
            if (state == 2)
            {
                currentFrame++;
                if (currentFrame == frameCount)
                {
                    currentFrame = 0;
                    state = 1;
                    Restart();
                }
            }
        }

        /* --------------------------------------------------------------
           -----------------------      ISENABLED     -------------------
           -------------------------------------------------------------- */
        public bool isEnabled()
        {
            if (state > 0) return true;
            else
            return false;
        }

        private void SetSize()
        {
            size = RandomNumber(minSize, maxSize);
            
        }

        public void Hit()
        {
            //size = RandomNumber(minSize, maxSize);

        }

        /* --------------------------------------------------------------
           ----------------------      SETSTARPOS     -------------------
           -------------------------------------------------------------- */
        private void SetStartPos()
        {
            int x = RandomNumber(0, scx);
            int y = RandomNumber(0, scy);
            int left = x;          //1
            int rigt = scx - x;    //2
            int top = y;           //3
            int bottom = scy - y;  //4
            int akt = Minker(left, rigt, top, bottom);
            //akt = 4;
            switch (akt)
            {
                case 1:
                    position.X = -size;
                    position.Y = y;
                    velocity.X = (float)VeolcityRandom();  // 0.1f - kb 7-10ig
                    velocity.Y = (float)VeolcityRandom() * RandomSign();
                break;
                case 2:
                    position.X = scx + size;
                    position.Y = y;
                    velocity.X = (float)-VeolcityRandom();  // 0.1f - kb 7-10ig
                    velocity.Y = (float)VeolcityRandom() * RandomSign(); //* (float)RandomSign();
                break;
                case 3:
                    position.X = x;
                    position.Y = -size;
                    velocity.X = (float)VeolcityRandom() * RandomSign();  // 0.1f - kb 7-10ig
                    velocity.Y = (float)VeolcityRandom();
                break;
                case 4:
                    position.X = x;
                    position.Y = scy + size;
                    velocity.X = (float)VeolcityRandom() * RandomSign();  // 0.1f - kb 7-10ig
                    velocity.Y = (float)-VeolcityRandom();
                    break;
            }
            //position.X = 330;
            //position.Y = 330;
            rotationVelocity = (float)RotationRandom() * RandomSign();
        }

        /* --------------------------------------------------------------
           ---------------------      SEGÉDFÜGGVÉNYEK     ---------------
           -------------------------------------------------------------- */
        private int Minker(int a, int b, int c, int d)
        {
            int temp = a;
            if (b<temp) temp = b;
            if (c<temp) temp = c;
            if (d<temp) temp = d;
            if (temp == a) return 1;
            if (temp == b) return 2;
            if (temp == c) return 3;
            if (temp == d) return 4;
            return 2;
        }

        private int RandomSign()
        {
            int i = RandomNumber(0, 2);
            if (i == 0) return 1;
            else
                return -1;
        }

        private int RandomNumber(int min, int max)
        {
            return random.Next(min, max);
        }

        private double RotationRandom()
        {
            return random.NextDouble()*0.2;
        }

        private double VeolcityRandom()
        {
            return (random.NextDouble() * (MaxVelocity - MinVelocity)) + MinVelocity;
        }

    }
}
